# Stack-Parser

------

This is small executable that prints function names and line numbers for hexadecimal stack dumps. This is useful to analyze customer's crash reports without having to ship the .PDB files.

Concretelly, stackParser.exe takes the .PDB file created by Visual Studio at build time, and the crash log text file containing a set of 64 bit addresses. Then stackParser will spit out the function name and source code line number for that address inside the binary to which the binary is associated. There are little restrictions to what the crawh log should be formated like, so it's easy to integrate in any project.

## Usage

```C:\> stackParser.exe input.txt input.pdb```

input.txt can is the text file with the hex addresses. It can contain other information interleaved, as long as the hex addresses are the beginning of a line. For example, for this input.txt file:

```Error log
Program started correctly
Entering render loop
Crash while rendering!
Stack:
00007ffbd27d4f99
0000000140978214
0000000140075485
00000001400757f4
0000000140958bb6
0000000140028608
00000001400b5aa1
00000001400b7626
0000000140972e72```


The output of stackParser.exe (on stdout) will be:


```00007ffbd27d4f99 : Failed to lookup
0000000140978214 : _CxxThrowException, line 75
0000000140075485 : std::filesystem::_Throw_fs_error, line 1810
00000001400757f4 : Demo::UI::SaveDialog::iOpen, line 156
0000000140958bb6 : Demo::UI::Interact, line 1224
0000000140028608 : Demo::Demo::Render, line 2267
00000001400b5aa1 : Demo::MainApp::Loop, line 751
00000001400b7626 : main, line 1414
0000000140972e72 : __scrt_common_main_seh, line 288```

## Requirements

Visual Studio 2019

## License

[WTFPL license](https://en.wikipedia.org/wiki/WTFPL)

## Credits

[Inigo Quilez](https://iquilezles.org)
